;##################################################################
; WindowTest
;##################################################################

#include WindowTest.h

/*
DEBUGLIB equ \Programming\RadASM3\GoAsm\dbg\Debug.lib
DEBUGEXE equ "\Programming\RadAsm\GoAsm\dbg\dbgwin.exe"

#include "\Programming\RadASM3\GoAsm\dbg\debug.a"
DBGWIN_DEBUG_ON = 0 // use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 // setting this to 1 will suppress PrintError if no error exists
*/

DATA SECTION
	ClassName			DB "MainWinClass",0
	AppName				DB "Main Window",0
	ClassName2			DB "SuperStat",0
	ALIGN 4
	hInstance			HANDLE ?
	CommandLine			HANDLE ?
	hBrush				HANDLE ?

	crv					COLORREF 16 DUP (?)

CODE SECTION

START:

	invoke GetModuleHandle, NULL
	mov [hInstance],eax
	invoke GetCommandLine
	mov [CommandLine],eax
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,[CommandLine],SW_SHOWNORMAL
	invoke ExitProcess,eax

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:%HANDLE

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov [wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInstance]
	pop [wc.hInstance]
	invoke CreateSolidBrush,0xFFFFFF
	mov D[wc.hbrBackground],eax
	mov D[wc.lpszMenuName],NULL
	mov [wc.lpszClassName],OFFSET ClassName

	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax

	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,NULL,ADDR ClassName,NULL,\
			WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
			CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
			[hInst],NULL

	mov [hwnd],eax

	invoke GetClassInfoEx,NULL,"STATIC",offset wc
	mov eax,offset ClassName2
	mov [wc.lpszClassName],eax
	invoke CreateSolidBrush,0xFF00
	mov [hBrush],eax
	mov [wc.hbrBackground],eax
	mov eax,offset SomeClassProc
	mov [wc.lpfnWndProc],eax
	invoke RegisterClassEx, addr wc

	invoke CreateWindowEx,NULL,"BUTTON",NULL,BS_PUSHBUTTON + WS_CHILD + WS_VISIBLE,100,100,30,30,[hwnd],1001,[hInst],NULL

	invoke CreateWindowEx,NULL,offset ClassName2,NULL,WS_CHILD + WS_VISIBLE,50,50,30,30,[hwnd],1002,[hInst],NULL

	invoke ShowWindow, [hwnd],[CmdShow]
	invoke UpdateWindow, [hwnd]

	.messloop
		invoke GetMessage, ADDR msg,0,0,0
		or eax,eax
		JZ >.quit
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage, ADDR msg
	JMP .messloop
	.quit

	mov eax,[msg.wParam]
	ret
ENDF

SomeClassProc FRAME hwnd, uMsg, wParam, lParam
	invoke DefWindowProc, [hwnd], [uMsg], [wParam], [lParam]
	ret
endf

WndProc FRAME hwnd, uMsg, wParam, lParam
	uses ebx
	LOCAL hb:LOGBRUSH

	cmp D[uMsg],WM_CREATE
	jne >.WM_COMMAND
		jmp >>.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >>.WM_CLOSE
		// Change the brush
		invoke CreateSolidBrush,0xFF
		mov ebx,eax
		invoke GetDlgItem,[hwnd],1002
		invoke SetClassLong,eax,GCL_HBRBACKGROUND,ebx

		// Kill the window and its class
		invoke SendDlgItemMessage,[hwnd],1002,WM_CLOSE,0,0
		invoke UnregisterClass,offset ClassName2,[hInstance]
		// Make sure our class has been properly unregistered
		test eax,eax
		jnz >
			invoke MessageBox,NULL,"Class was not unregistered",NULL,NULL
			jmp >>.EXIT
		:

		invoke GetObject,[hBrush],SIZEOF LOGBRUSH,offset hb
		// If GetObject returns 0 the original brush was deleted when the
		// the class was unregistered
		test eax,eax
		jnz >
			invoke MessageBox,NULL,"GetObject failed, Hutch was right",NULL,NULL
			jmp >>.EXIT
		:
		invoke MessageBox,NULL,"GetObject was successful, Edgar was right",NULL,NULL
		jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.WM_DESTROY
		invoke DestroyWindow,[hwnd]
		jmp >>.EXIT

	.WM_DESTROY
	cmp D[uMsg],WM_DESTROY
	jne >.DEFPROC
		invoke PostQuitMessage,NULL
		jmp >>.DEFPROC

	.DEFPROC
		invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]		
		ret

	.EXIT

	xor eax,eax
	ret
ENDF

SelectColor FRAME hWin, instance, dwFlags
	LOCAL ccl:CHOOSECOLOR

	mov edi,offset crv
	mov D[ccl.lpCustColors],edi
	mov ecx,16
	mov eax,0FFFFFFh
	rep stosd

	mov D[ccl.lStructSize],sizeof CHOOSECOLOR
	push [hWin]
	pop [ccl.hwndOwner] 
	push [instance]
	pop [ccl.hInstance]
	push [dwFlags]
	pop [ccl.Flags]

	xor eax,eax
	mov [ccl.rgbResult],eax
	mov [ccl.lCustData],eax
	mov [ccl.lpfnHook],eax
	mov [ccl.lpTemplateName],eax

	invoke ChooseColor,addr ccl

	; Check for cancel
	test eax,eax
	jz >
		mov eax,[ccl.rgbResult]
		ret
	:
		mov eax,-1
		ret
ENDF
